#!/bin/bash
#if [ -f /usr/lib/systemd/user/dbus.service ]; then

SWITCH_LOG_FILE="$HOME/switch_sess.txt"

#set -xue
#echo -n >> "$SWITCH_LOG_FILE"
#echo -e "incoming session: \n\txdg_session_id=${XDG_SESSION_ID:-}\n\txrdp=\"${XRDP_SESSION:-}\"\n\tx2go=\"${X2GO_SESSION:-}\"" >> "$SWITCH_LOG_FILE"

if [ -z ${XRDP_SESSION:-} ] && [ -z ${X2GO_SESSION:-} ]; then
  #echo -e "\tsession is local" >> "$SWITCH_LOG_FILE"
  CHECK="Remote=no"
else
  #echo -e "\tsession is remote" >> "$SWITCH_LOG_FILE"
  CHECK="Remote=yes"
fi

for sess in `loginctl show-user $USER |grep Sessions= | cut -f2 -d'='`; do
  #echo -n "Checking session \"$sess\": " >> "$SWITCH_LOG_FILE"

  if [[ "$sess" == "$XDG_SESSION_ID" ]]; then
    #echo "Skip current session" >> "$SWITCH_LOG_FILE"
    continue;
  fi

  if loginctl show-session "$sess" | grep "$CHECK" ; then
    #echo -e "\n\tSession $sess is \"$CHECK\"" >> "$SWITCH_LOG_FILE"

    SESS_TYPE=`loginctl show-session $sess | grep Type= | cut -f2 -d'='`
    #echo -e "\tSession $sess type=$SESS_TYPE" >> "$SWITCH_LOG_FILE"

    SESS_STATE=`loginctl session-status $sess --no-pager -n 0 | grep -E "^\s*State:" | sed "s/.*[[:space:]]//"`
    #echo -e "\tSession $sess type=$SESS_TYPE state=$SESS_STATE" >> ~/switch_sess.txt
    case $SESS_STATE in
        closing)
            #echo -e "\tSession is closing - skip" >> ~/switch_sess.txt
            continue ;;
    esac

    case $SESS_TYPE in
      "x11"|"wayland")
        case "$LANG" in
          "ru_RU.UTF-8") fly-dialog --caption "Внимание!"  --error "У пользователя $USER уже есть открытая графическая сессия $sess. Переключаю на нее." || true;;
          *)             fly-dialog --caption "Attention!" --error "User $USER has other open GUI session $sess. Switching to it." || true
        esac
        #echo "Try to activate sess=\"$sess\", will fail for nested sessions" >> "$SWITCH_LOG_FILE"
        loginctl activate $sess &>> "$SWITCH_LOG_FILE"
        #echo "Try to unlock sess=\"$sess\", Unlock signal may be ignored by session mgr" >> "$SWITCH_LOG_FILE"
        loginctl unlock-session $sess &>> "$SWITCH_LOG_FILE"
        exit 1
        ;;
    esac
  #else
    #echo "Skip not \"$CHECK\" session" >> "$SWITCH_LOG_FILE"
  fi

done

#fi

exit 0
